﻿
;-  Add your game description here for DoublePendulum
;
;
Global  *sp1.cpSprite

Procedure initFuncDoublePendulum()

  
  initFunc()
  cpSpaceSetGravity(*space, cpv(_A, 0, 500));
  cpSpaceSetIterations(*space, 1)  
    SetChipmunk4PBDebugFlag(0)
  ; First stick
  *pos1.cpVect = cpv(pos1.cpVect, wx/2,  200);      
   *sp1 =  CreateSegmentElement(*space, *pos1\x,  *pos1\y, *pos1\x + #ArmLength1, *pos1\y, 0, #NormalBody)
  cpShapeSetMass(*sp1\shape, 50)
  *constraint1 = cpSpaceAddConstraint(*space, cpPinJointNew(*sp1\body, cpSpaceGetStaticBody(*space), *pos1, *pos1));
  ; Second stick
  *pos2.cpVect = cpSegmentShapeGetB(_A, *sp1\shape)
  *sp2.cpSprite = CreateSegmentElement(*space, *pos2\x,  *pos2\y, *pos2\x + #ArmLength2, *pos2\y, 0, #NormalBody)
  cpShapeSetMass(*sp2\shape, 100)
  *constraint2 = cpSpaceAddConstraint(*space, cpPinJointNew(*sp2\body, *sp1\body, *pos2, *pos2));
  
EndProcedure


Procedure updateFuncDoublePendulum()
  updateFunc()
EndProcedure


Procedure destroyFuncDoublePendulum()
  destroyFunc()
EndProcedure


AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "Double Pendulum"
ChipmunkDemo()\timestep = 1.0/100
ChipmunkDemo()\initFunc = @initFuncDoublePendulum()
ChipmunkDemo()\updateFunc = @updateFuncDoublePendulum()
ChipmunkDemo()\destroyFunc = @destroyFuncDoublePendulum()
; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 27
; FirstLine = 2
; Folding = -
; EnableXP