﻿
Structure xy
  x.i
  y.i
EndStructure
Global NewList trace.xy()
#ArmLength1=100:
;#ArmLength2=35
#Mass1=3:
#Mass2=2
#MaxHistoricNumber=200
;departure angles
Global Angle1.f=-#PI/2:
Global Angle2.f=-#PI/2



Global x0.i=wx/2:
Global y0.i=wy/2:
Global x1.i=0:
Global y1.i=0:
Global x2.i=0:
Global y2.i=0
Global acceleration1.f=0.0:
Global acceleration2.f=0.0
Global vitesse1.f=0:
Global vitesse2.f=0
Global g.f=1

Global NewList sp.cpSprite()
Global *sp.cpSprite
Global *spPrev.cpSprite = #Null
Global NewList traceCP.xy()

Procedure initFuncDoublePendulumBoth()
  ;   initFunc()
  ;   cpSpaceSetGravity(*space, cpv(_A, 0, 50));
  ;   cpSpaceSetIterations(*space, 60)  
  ;   SetChipmunk4PBDebugFlag(0)
  ;   
  ;   #StaticBody = 0
  ; 	#KinematicBody = 1
  #NormalBody = 2
  ; 	
  ; 	; First stick
  ; 	 AddElement(sp())
  ;   *pos1.cpVect = cpv(pos1.cpVect, wx/2,  wy/2);      
  ;   *sp() =  CreateSegmentElement(*space, *pos1\x,  *pos1\y, *pos1\x - #ArmLength1, *pos1\y, 0, #NormalBody)
  ;   cpShapeSetMass(*sp1\shape, 1)
  ;   cpShapeSetFriction(*sp1\shape, 0)
  ;   *constraint1 = cpSpaceAddConstraint(*space, cpPinJointNew(*sp1\body, cpSpaceGetStaticBody(*space), *pos1, *pos1));
  ; 
  ;   ; Second stick
  ;   *pos2.cpVect = cpv(pos2.cpVect, *pos1\x - #ArmLength1,  *pos1\y); 
  ;   *sp2.cpSprite = CreateSegmentElement(*space, *pos2\x,  *pos2\y, *pos2\x - #ArmLength2, *pos2\y, 0, #NormalBody)
  ;   cpShapeSetMass(*sp2\shape, 1)
  ;     cpShapeSetFriction(*sp2\shape, 0)
  ;     *constraint2 = cpSpaceAddConstraint(*space, cpPinJointNew(*sp2\body, *sp1\body, *pos2, *pos2));
  ;     
  initFunc()
  ;SetChipmunk4PBDebugFlag(0)
  cpSpaceSetGravity(*space, cpv(_A,0, 10)); 
  cpSpaceSetIterations(*space, 60)  
  Protected nSegments = 2
  
  For n = 1 To nSegments
    AddElement(sp())
    If ListSize(sp()) = 1
      *pos1.cpVect = cpv(pos1.cpVect, wx/2,  wy/2); 
      *sp = CreateSegmentElement(*space, *pos1\x,  *pos1\y, *pos1\x - #ArmLength1, *pos1\y, 0, #NormalBody)
      cpSpaceAddConstraint(*space, cpPinJointNew(*sp\body, cpSpaceGetStaticBody(*space), *pos1, *pos1));   
    Else
      *pos.cpVect = cpSegmentShapeGetB(pos.cpVect, *sp\shape)
      *sp = CreateSegmentElement(*space, *pos\x,  *pos\y, *pos\x - #ArmLength2, *pos\y, 0, #NormalBody)
      cpSpaceAddConstraint(*space, cpPinJointNew(*spPrev\body, *sp\body, *pos, *pos))
    EndIf
    CopyStructure(*sp, sp(), cpSprite)
    cpShapeSetMass(sp()\shape, 1)
    *spPrev = sp()
  Next
  
EndProcedure


Procedure updateFuncDoublePendulumBoth()
  
  updateFunc()
  
  
  num1.f=-g*(2*#Mass1+#Mass2)*Sin(Angle1)
  num2.f=-g*#Mass2*Sin(Angle1-2*Angle2)
  num3.f=-2*#Mass2*Sin(Angle1-Angle2)
  num4.f=vitesse2*vitesse2*#ArmLength2+vitesse1*vitesse1*#ArmLength1*Cos(Angle1-Angle2)
  num.f=num1+num2+num3*num4
  den.f=2*#Mass1+#Mass2-#Mass2*Cos(2*Angle1-2*Angle2)
  den.f=den*#ArmLength2
  acceleration1=num/den
  
  num1.f=2*Sin(Angle1-Angle2)
  num2.f=vitesse1*vitesse1*#ArmLength1*(#Mass1+#Mass2)
  num3.f= g*(#Mass1+#Mass2)*Cos(Angle1)
  num4.f=vitesse2*vitesse2*#ArmLength2*#Mass2*Cos(Angle1-Angle2)
  num.f=(num2+num3+num4)
  num=num1*num
  den.f  =#ArmLength2*(2*#Mass1+#Mass2-(#Mass2*Cos(2*Angle1-2*Angle2)))
  acceleration2=num/den
  
  vitesse1+acceleration1
  vitesse2+acceleration2
  Angle1+vitesse1
  Angle2+vitesse2
  x1=x0+#ArmLength1*Sin(Angle1)
  y1=y0+#ArmLength1*Cos(Angle1)
  x2=x1+#ArmLength2*Sin(Angle2)
  y2=y1+#ArmLength2*Cos(Angle2)
  If FirstElement(trace())
    xold.i=trace()\x:yold.i=trace()\y
    If ListSize(trace())>#MaxHistoricNumber:DeleteElement(trace()):EndIf
    LastElement(trace())
  EndIf
  AddElement(Trace())
  Trace()\x=x2
  Trace()\y=y2
  
  StartDrawing(ScreenOutput())
  
  ForEach trace()
    colorR.i=ListIndex(trace())*255/ListSize(trace())
    LineXY(trace()\x,trace()\y,xold,yold,RGB(colorR,0,0))
    xold=trace()\x:yold=trace()\y
  Next
  LineXY(x0,y0,x1,y1,#White)
  LineXY(x1,y1,x2,y2,#White)
  Circle(x1,y1,#Mass1)
  Circle(x2,y2,#Mass2)
  
  ForEach sp()
    *pos.cpVect = cpBodyLocalToWorld(pos.cpVect, cpShapeGetBody(sp()\shape), cpSegmentShapeGetA(_A, sp()\shape));
    Circle(*pos\x , *pos\y, #Mass2, #Green)
    If FirstElement(traceCP())
      xold1.i=trace()\x:yold1.i=trace()\y
      If ListSize(traceCP())>#MaxHistoricNumber:DeleteElement(traceCP()):EndIf
      LastElement(traceCP())
      AddElement(traceCP())
      ForEach traceCP()
        colorR1.i=ListIndex(traceCP())*155/ListSize(traceCP())
        LineXY(traceCP()\x,traceCP()\y,xold1,yold1,RGB(colorR1,colorR1,0))
        xold1=traceCP()\x:yold1=traceCP()\y
      Next
      traceCP()\x=*pos\x
      traceCP()\y=*pos\y
    EndIf
    AddElement(Trace())
    Trace()\x=x2
    Trace()\y=y2
    
  Next
  StopDrawing()
  
  
EndProcedure


Procedure destroyFuncDoublePendulumBoth()
  destroyFunc()
EndProcedure


AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "Double Pendulum"
ChipmunkDemo()\timestep = 1.0/10
ChipmunkDemo()\initFunc = @initFuncDoublePendulumBoth()
ChipmunkDemo()\updateFunc = @updateFuncDoublePendulumBoth()
ChipmunkDemo()\destroyFunc = @destroyFuncDoublePendulumBoth()
; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 63
; FirstLine = 36
; Folding = -
; EnableXP