



;-  Add your game description here for PyramidStack
;
;

Procedure initFuncPyramidStack()

  initFunc()
  SetChipmunk4PBDebugFlag(0)
  
  cpSpaceSetIterations(*space, 30);
  cpSpaceSetGravity(*space, cpv(_A, 0, 100))
  cpSpaceSetSleepTimeThreshold(*space, 0.5)
  cpSpaceSetCollisionSlop(*space, 0.5)     
  
  *staticBody.cpBody = cpSpaceGetStaticBody(*space)
  *body.cpBody = cpSpaceGetStaticBody(*space)       

  ; Create segments around the edge of the screen.
  *shape.cpShape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A, 0,0), cpv(_B,0,wy-1), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                                       
  cpShapeSetFriction(*shape, 1.0)                                                                         
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,0,wy-1), cpv(_B,wx-1,wy-1), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                                       
  cpShapeSetFriction(*shape, 1.0)                                                                         
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,wx-1,wy-1), cpv(_B,wx-1,0), 0.0));
  cpShapeSetElasticity(*shape, 1.0)                                                                       ;
  cpShapeSetFriction(*shape, 1.0)                                                                         ;
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER)                                                          ;
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,wx-1,0), cpv(_B,0,0), 0.0));
  cpShapeSetElasticity(*shape, 1.0)                                                                 ;
  cpShapeSetFriction(*shape, 1.0)   
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER)
  
  ; Add lots of boxes.
  iMax = 15
  For i=0 To iMax
    For j=0 To iMax-i
      *box.cpSprite = Body_BoxAdd(60+j*32 + i*16, -50+wy-i*32, 30, 30, 1)
       cpShapeSetElasticity(*box\shape, 0.0)                                      
       cpShapeSetFriction(*box\shape, 0.8)                                        
    Next j
  Next i
  
  ;Add a ball To make things more interesting
  radius.cpFloat = 14.0;
  *body = cpSpaceAddBody(*space, cpBodyNew(10.0, cpMomentForCircle(10.0, 0.0, radius, cpvzero))) 
  *circle.cpSprite = Body_CircleAdd(60+j*32 + i*16, -50+wy-i*32, radius, 1)
  cpBodySetPosition(*circle\body, cpv(_A, wx/2-radius/2, wy - radius))                                           
  cpShapeSetElasticity(*circle\shape, 0.0)                                         
  cpShapeSetFriction(*circle\shape, 0.9)                                           
  
EndProcedure


Procedure updateFuncPyramidStack()
  updateFunc()
EndProcedure


Procedure destroyFuncPyramidStack()
  destroyFunc()
EndProcedure


AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "PyramidStack"
ChipmunkDemo()\timestep = 1.0/45.0
ChipmunkDemo()\initFunc = @initFuncPyramidStack()
ChipmunkDemo()\updateFunc = @updateFuncPyramidStack()
ChipmunkDemo()\destroyFunc = @destroyFuncPyramidStack()
ChipmunkDemo()\description = ""
; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 46
; FirstLine = 23
; Folding = -
; EnableXP
; SubSystem = DX9
; DisableDebugger
; HideErrorLog