;-  Add your game description here for PyramidTopple
;
;

Procedure add_domino(*space.cpSpace, *pos.cpVect, flipped.cpBool)
  WIDTH = 4.0: 
  HEIGHT = 30.0
  mass.cpFloat = 1.0
  
  moment.cpFloat = cpMomentForBox(mass, WIDTH, HEIGHT);
  
  ;*body.cpBody = cpSpaceGetStaticBody(*space)
  *body.cpBody = cpSpaceAddBody(*space, cpBodyNew(mass, moment))
  cpBodySetPosition(*body, *pos)
  
  
  
  
  *shape.cpShape
  
  If flipped 
    *box.cpSprite = Body_BoxAdd(*pos\x, *pos\y, WIDTH, HEIGHT, 1)
  ;  *shape = cpBoxShapeNew(*body, WIDTH, HEIGHT, 0.0)
  Else
    *box.cpSprite = Body_BoxAdd(*pos\x, *pos\y, HEIGHT, WIDTH, 1)
   ; *shape =cpBoxShapeNew(*body, HEIGHT, WIDTH, 0.0) 
  EndIf
  
 ; cpSpaceAddShape(*space, *shape)
  cpShapeSetElasticity(*box\shape, 0.0)
  cpShapeSetFriction(*box\shape, 0.6)  
EndProcedure



Procedure initFuncPyramidTopple()
  initFunc()
  SetChipmunk4PBDebugFlag(0)
  ; Add a floor.
  ; cpShape *shape = cpSpaceAddShape(space, cpSegmentShapeNew(cpSpaceGetStaticBody(space), cpv(-600,-240), cpv(600,-240), 0.0f));
  *shape.cpshape = cpSpaceAddShape(*space, cpSegmentShapeNew(cpSpaceGetStaticBody(*space), cpv(A.cpvect,0,wy-10), cpv(B.cpvect,wx,wy-10), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                                                        
  cpShapeSetFriction(*shape, 1.0)                                                                                          
  ;cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER)                                                                           
  WIDTH = 4.0
  HEIGHT = 30.0
  
  ; Add the dominoes.
  n = 11
  For i = 0 To n
    For j = 0 To n - i
      
;       cpVect offset = cpv((j - (n - 1 - i)*0.5f)*1.5f*HEIGHT, (i + 0.5f)*(HEIGHT + 2*WIDTH) - WIDTH - 240);
; 			add_domino(space, offset, cpFalse);
; 			add_domino(space, cpvadd(offset, cpv(0, (HEIGHT + WIDTH)/2.0f)), cpTrue);
; 			
; 			If(j == 0){
; 				add_domino(space, cpvadd(offset, cpv(0.5f*(WIDTH - HEIGHT), HEIGHT + WIDTH)), cpFalse);
; 			}
; 			
; 			If(j != n - i - 1){
; 				add_domino(space, cpvadd(offset, cpv(HEIGHT*0.75f, (HEIGHT + 3*WIDTH)/2.0f)), cpTrue);
; 			} Else {
; 				add_domino(space, cpvadd(offset, cpv(0.5f*(HEIGHT - WIDTH), HEIGHT + WIDTH)), cpFalse);
; 			}
            *offset.cpVect = cpv(offset.cpVect, (wx/2-HEIGHT+(j - (n - 1 - i)*0.5)*1.5*HEIGHT), wy-10-WIDTH-(i + 0.5)*(HEIGHT + 2*WIDTH) - WIDTH )
      add_domino(*space, *offset, #False)
      add_domino(*space, cpvadd(B, *offset, cpv(A, 0, (HEIGHT + WIDTH)/2.0)), #True)
      
      If j = n-i
        add_domino(*space, cpvadd(B, *offset, cpv(A, 0.5*(HEIGHT - WIDTH), -HEIGHT + 3*WIDTH)), #True)
      Else
        add_domino(*space, cpvadd(B, *offset, cpv(A, HEIGHT-HEIGHT/4, -WIDTH )), #False)
      EndIf
      If j = 0       
        add_domino(*space, cpvadd(B, *offset, cpv(A, 0.5*(WIDTH - HEIGHT), -HEIGHT+ 3*WIDTH)), #True)
      EndIf
      
      
      
;       *offset.cpVect = cpv(offset.cpVect, (wx/2-HEIGHT+(j - (n - 1 - i)*0.5)*1.5*HEIGHT), wy-10-WIDTH-(i + 0.5)*(HEIGHT + 2*WIDTH) - WIDTH )
;       add_domino(*space, *offset, #False)
;       add_domino(*space, cpvadd(B, *offset, cpv(A, 0, (HEIGHT + WIDTH)/2.0)), #True)
;       
;       If j = n-i
;         add_domino(*space, cpvadd(B, *offset, cpv(A, 0.5*(HEIGHT - WIDTH), -HEIGHT + 3*WIDTH)), #True)
;       Else
;         add_domino(*space, cpvadd(B, *offset, cpv(A, HEIGHT*0.75, (HEIGHT + 3*WIDTH)/2.0 )), #False)
;       EndIf
;       If j = 0       
;         add_domino(*space, cpvadd(B, *offset, cpv(A, 0.5*(WIDTH - HEIGHT), -HEIGHT+ WIDTH)), #True)
;       EndIf
    Next
  Next
EndProcedure


Procedure updateFuncPyramidTopple()
  updateFunc()
EndProcedure


Procedure destroyFuncPyramidTopple()
  destroyFunc()
EndProcedure


AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "PyramidTopple"
ChipmunkDemo()\timestep = 1.0/45.0
ChipmunkDemo()\initFunc = @initFuncPyramidTopple()
ChipmunkDemo()\updateFunc = @updateFuncPyramidTopple()
ChipmunkDemo()\destroyFunc = @destroyFuncPyramidTopple()
; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 37
; FirstLine = 18
; Folding = -
; EnableXP