
;-  Add your game description here for Chains
;
;
Global CHAIN_COUNT = 8
Global LINK_COUNT = 10

Global *prev.cpBody = #Null;

Procedure initFuncChains()
  
  initFunc()
    SetChipmunk4PBDebugFlag(1)
  
  *body.cpBody
  *staticBody.cpBody = cpSpaceGetStaticBody(*space);
  *shape.cpShape
  
  ;Create segments around the edge of the screen.

  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,0,0), cpv(_B,0,wy-1), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                               
  cpShapeSetFriction(*shape, 1.0)                                                                 
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,0,wy-10), cpv(_B,wx-1,wy-10), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                                       
  cpShapeSetFriction(*shape, 1.0)                                                                         
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,wx-1,wy-1), cpv(_B,wx-1,0), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                                     
  cpShapeSetFriction(*shape, 1.0)                                                                       
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,wx-1,0), cpv(_B,0,0), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                               
  cpShapeSetFriction(*shape, 1.0)                                                                 
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  
  
;   If CreateImage(1, 31, 31)
;     StartDrawing(ImageOutput(1))
;     For n = 15 To 1 Step -2
;       Circle(15,15,n,$FFFFFF/n)
;     Next 
;     Box(10,10,11,11,#Blue)
;     StopDrawing() ; This is absolutely needed when the drawing operations are finished !!! Never forget it !
;     Texture = MP_ImageToTexture(1)  
;     Global sprite1 = MP_SpriteFromTexture(Texture) 
;   EndIf
;   *aSprite1.cpSprite =  CreateCircleElement(*space, 390, 540 + radius+5, 15, 0)
;   *body = *aSprite1\body
;   *shape = *aSprite1\shape
;   *aSprite1\spriteID = sprite1
;   cpBodySetVelocity(*body, cpv(cpVect,0, -5000));
;   cpShapeSetElasticity(*shape, 0.0)             ;
;   cpShapeSetFriction(*shape, 0.9)    
  
  ;mass.cpFloat = 1;
  width.cpFloat = 20;
  height.cpFloat = 30;
  
  spacing.cpFloat = width*0.3;
  
  ; Add lots of boxes.
  ;// Add lots of boxes.
   CompilerIf Subsystem("DX9")
    If CreateImage(0, 20, 30)
    StartDrawing(ImageOutput(0))
    Box(0,0,20,30,#Red)
    Box(5,5,10,20,#Blue)
    Box(8,10,4,10,#Red)
    StopDrawing() ; This is absolutely needed when the drawing operations are finished !!! Never forget it !
    Texture = MP_ImageToTexture(0)  
    Global sprite = MP_SpriteFromTexture(Texture) 
  EndIf
CompilerElse
CompilerEndIf
  
  

  
  For i = 1 To CHAIN_COUNT
    *prev = #Null;
    For j=1 To LINK_COUNT
      
      *pos.cpVect = cpv(pos.cpVect, 200+width*i*2.1,  height*j*1.3-10);
      
      *aSprite.cpSprite =  CreateBoxElement(*space, 200+width*i*2.1,  height*j*1.3-10, width, height, 0)
      *aSprite\spriteID = sprite
      
      cpShapeSetFriction(*aSprite\shape, 1);
      
      breakingForce.cpFloat = 800000;
      *constraint.cpConstraint = #Null;
      
      If *prev = #Null
        *constraint = cpSpaceAddConstraint(*space, cpSlideJointNew(*aSprite\body, *staticBody, cpv(_A, 0, -height/2), cpv(_B, *pos\x, 0), 0, 10));
      Else 
        *constraint = cpSpaceAddConstraint(*space, cpSlideJointNew(*aSprite\body, *prev, cpv(_A,0, -height/2), cpv(_B, 0, height/2), 0, 10));
      EndIf
      
      cpConstraintSetMaxForce(*constraint, breakingForce);
      cpConstraintSetPostSolveFunc(*constraint, @BreakableJointPostSolve());
      
      *prev = *aSprite\body;
    Next
  Next
  
  
  
  ;   For i = 0 To  CHAIN_COUNT
  ;     *prev.cpBody = NULL
  ;     
  ;     For j = 0 To LINK_COUNT
  ;       *pos.cpVect = cpv(A, 40*(i - (CHAIN_COUNT - 1)/2.0), 240 - (j + 0.5)*height - (j + 1)*spacing);
  ;       
  ;       *body = cpSpaceAddBody(*space, cpBodyNew(mass, cpMomentForBox(mass, width, height)));
  ;       cpBodySetPosition(*body, *pos)
  ;       
  ;       *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*body, cpv(A,0, (height - width)/2.0), cpv(B,0, (width - height)/2.0), width/2.0));
  ;       cpShapeSetFriction(*shape, 0.8)
  ;       
  ;       breakingForce.cpFloat = 80000;
  ;       
  ;       *constraint.cpConstraint = NULL;
  ;       If *prev = #Null 
  ;         *constraint = cpSpaceAddConstraint(*space, cpSlideJointNew(*body, *staticBody, cpv(A,0, height/2), cpv(B,*pos/x, 240), 0, spacing));
  ;       Else 
  ;         *constraint = cpSpaceAddConstraint(*space, cpSlideJointNew(*body, *prev, cpv(A,0, height/2), cpv(B,0, -height/2), 0, spacing));
  ;       EndIf
  ;       
  ;       cpConstraintSetMaxForce(*constraint, breakingForce);
  ;       cpConstraintSetPostSolveFunc(*constraint, @BreakableJointPostSolve());
  ;       cpConstraintSetCollideBodies(*constraint, cpFalse)
  ;       
  ;       *prev = *body;
  ;     Next
  ;   Next
  ;   
  ;   radius= 15.0;
  ;   *body = cpSpaceAddBody(*space, cpBodyNew(10.0, cpMomentForCircle(10.0, 0.0, radius, cpvzero)));
  ;   cpBodySetPosition(*body, cpv(A,0, -240 + radius+5))
  ;   cpBodySetVelocity(*body, cpv(A,0, 300))
  ;   
  ;   *shape = cpSpaceAddShape(*space, cpCircleShapeNew(*body, radius, cpvzero));
  ;   cpShapeSetElasticity(*shape, 0.0)
  ;   cpShapeSetFriction(*shape, 0.9)
  
EndProcedure


Procedure updateFuncChains()
  updateFunc()
EndProcedure


Procedure destroyFuncChains()
  destroyFunc()
EndProcedure


AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "Breakable Chains"
ChipmunkDemo()\timestep = 1.0/180
ChipmunkDemo()\initFunc = @initFuncChains()
ChipmunkDemo()\updateFunc = @updateFuncChains()
ChipmunkDemo()\destroyFunc = @destroyFuncChains()


; 
; Static void
; BreakablejointPostStepRemove(cpSpace *space, cpConstraint *joint, void *unused)
; {
; 	cpSpaceRemoveConstraint(space, joint);
; 	cpConstraintFree(joint);
; }
; 
; Static void
; BreakableJointPostSolve(cpConstraint *joint, cpSpace *space)
; {
; 	cpFloat dt = cpSpaceGetCurrentTimeStep(space);
; 	
; 	// Convert the impulse To a force by dividing it by the timestep.
; 	cpFloat force = cpConstraintGetImpulse(joint)/dt;
; 	cpFloat maxForce = cpConstraintGetMaxForce(joint);
; 
; 	// If the force is almost As big As the joint's max force, break it.
; 	If(force > 0.9*maxForce){
; 		cpSpaceAddPostStepCallback(space, (cpPostStepFunc)BreakablejointPostStepRemove, joint, NULL);
; 	}
; }
; 



; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 23
; FirstLine = 21
; Folding = -
; EnableXP