﻿
;-  Add your game description here for GrainsDeSable
;   http://www.purebasic.fr/french/viewtopic.php?f=2&t=17198
;



Procedure initFuncGrainsDeSable()
  initFunc()
  myEventMax = 8
  SetChipmunk4PBDebugFlag(0)
  cpSpaceSetIterations(*space, 20);
  cpSpaceSetGravity(*space, cpv(_A, 20, 20))
  cpSpaceSetSleepTimeThreshold(*space, 0.5)
  cpSpaceSetCollisionSlop(*space, 0.5)   
  
  *staticBody.cpBody = cpSpaceGetStaticBody(*space);
  *shape.cpShape                                   ;
  
  
  ; Create segments around the edge of the screen.
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,0,0), cpv(_B,0,wy-1), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                               
  cpShapeSetFriction(*shape, 1.0)                                                                 
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,0,wy-1), cpv(_B,wx-1,wy-1), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                                       
  cpShapeSetFriction(*shape, 1.0)                                                                         
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,wx-1,wy-1), cpv(_B,wx-1,0), 0.0));
  cpShapeSetElasticity(*shape, 1.0)                                                                       ;
  cpShapeSetFriction(*shape, 1.0)                                                                         ;
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER)                                                          ;
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,wx-1,0), cpv(_B,0,0), 0.0));
  cpShapeSetElasticity(*shape, 1.0)                                                                 ;
  cpShapeSetFriction(*shape, 1.0)   
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER)                                                   
  
  For i=0 To 80
    Body_CircleAdd(Random(wx-50,50),Random(wy-50,50), 6, 0)
    ; Body_BoxAdd(Random(wX-100,150), Random(20,0), Random(40,20), Random(40,20), 10)
  Next                                                               ; // emulate angular friction
EndProcedure


Procedure updateFuncGrainsDeSable()
  If lastEvent <> keyPressed
    Select keyPressed
      Case 3
        cpSpaceSetGravity(*space, cpv(_A, 20, 20))
        SetWindowTitle(0, ChipmunkDemo()\title + " down right")  
      Case 6
        cpSpaceSetGravity(*space, cpv(_A, 20, 0))
        SetWindowTitle(0, ChipmunkDemo()\title + " right")
      Case 9
        cpSpaceSetGravity(*space, cpv(_A, 20, -20))
        SetWindowTitle(0, ChipmunkDemo()\title + " right up") 
      Case 8
        cpSpaceSetGravity(*space, cpv(_A, 0, -20))
        SetWindowTitle(0, ChipmunkDemo()\title + " up") 
      Case 7
        cpSpaceSetGravity(*space, cpv(_A, -20, -20))
        SetWindowTitle(0, ChipmunkDemo()\title + " up left")      
      Case 4
        cpSpaceSetGravity(*space, cpv(_A, -20, 0))   
        SetWindowTitle(0, ChipmunkDemo()\title + " left") 
      Case 1
        cpSpaceSetGravity(*space, cpv(_A, -20, 20))
        SetWindowTitle(0, ChipmunkDemo()\title + " left down")
      Case 2
        cpSpaceSetGravity(*space, cpv(_A, 0, 20))
        SetWindowTitle(0, ChipmunkDemo()\title + " down")      
    EndSelect
    lastEvent = myEvent
  EndIf
  updateFunc()
EndProcedure


Procedure destroyFuncGrainsDeSable()
  destroyFunc()
EndProcedure


AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "Grains de sable"
ChipmunkDemo()\timestep = 1.0/20
ChipmunkDemo()\initFunc = @initFuncGrainsDeSable()
ChipmunkDemo()\updateFunc = @updateFuncGrainsDeSable()
ChipmunkDemo()\destroyFunc = @destroyFuncGrainsDeSable()
ChipmunkDemo()\description = "Press the Pad Numbers [1,2,3,6,9,8,7,4] and change the gravity of the box."

; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 52
; FirstLine = 39
; Folding = -
; EnableXP