;-  Add your game description here for Plink
;
;

Global  pos.cpVect
Global *pos.cpVect

ProcedureC eachBody(*body.cpBody, *unused)
  *pos = cpBodyGetPosition(pos, *body)
  If *pos\y > wy Or *pos\x > wy Or  *pos\y < 0 Or *pos\x < 0
    cpBodySetPosition(*body, cpv(_A, Random(wx/2+200, wx/2-200), 0))
  EndIf
EndProcedure


Procedure initFuncPlink()
  initFunc()
  Static *body.cpBody 
  Static *shape.cpShape
  *staticBody.cpBody = cpSpaceGetStaticBody(*space)
  
  cpSpaceSetGravity(*space, cpv(_A, 0, 100));
  cpSpaceSetIterations(*space, 20)  
  SetChipmunk4PBDebugFlag(1)
  
  ChipmunkDemoMessageString.s = "Right click to make pentagons static/dynamic.";
  
  
  ; Vertexes For a triangle shape.
  Global Dim tris.cpVect(3)
  ;   cpv(tris(0),10,20)
  ;   cpv(tris(1),  0, -10)
  ;   cpv(tris(2), -10,20)
  
  cpv(tris(0), 10, 15)
  cpv(tris(1), 0, -10)
  cpv(tris(2), -10,15)
  
  ; Create the Static triangles.
  For x=0 To 8
    For y=0 To 7
      s = 20+35*y%2
      *offset.cpVect =cpv(offset.cpVect, x*70+s, 50+y*70 )
      
      *shape = cpPolyShapeNew(*staticBody, ArraySize(tris()), tris(), cpTransformTranslate(cpTransform.cpTransform, *offset) , 0.0)
      cpSpaceAddShape(*space, *shape);                                                                                                                           ;
      cpShapeSetElasticity(*shape, 1.0)                                                                                                                          ;
      cpShapeSetFriction(*shape, 1.0)                                                                                                                            ;
      cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER)     
      *a.cpSprite = AllocateStructure(cpSprite)
      *a\shape = *shape
      *a\body = cpShapeGetBody(*shape)
      *a\SpriteID = CreateSprite(#PB_Any,32,32)
      StartDrawing(SpriteOutput(*a\SpriteID))
      Circle(16,16,16,#Green)
      StopDrawing()
      cpShapeSetUserData(*a\shape, *a);
    Next
  Next
  
  NUM_VERTS = 5
  Dim COIN.cpVect(NUM_VERTS-1)
  For i=0 To NUM_VERTS-1
    angle.f = -2.0 * #PI * i / NUM_VERTS
    cpv(COIN(i), 10*Cos(angle), 10*Sin(angle))
  Next
  
  pentagon_mass.cpFloat = 1.0;
  pentagon_moment.cpFloat = cpMomentForPoly(1.0, NUM_VERTS, COIN(), cpvzero, 0.0);
  
  ; Add lots of pentagons.
  For n = 0 To 50
    *body = cpSpaceAddBody(*space, cpBodyNew(pentagon_mass, pentagon_moment));
     cpBodySetPosition(*body, cpv(_A, Random(wx/2+200, wx/2-200), -100))
  ;  cpBodySetPosition(*body, cpv(pos, wx/2, wy/2));
  ;  cpBodySetPosition(*body, cpv(pos, Random(wx/x +220, wx/2-220), wy/2));
    
    *shape = cpSpaceAddShape(*space, cpPolyShapeNew(*body, NUM_VERTS, COIN(), cpTransformIdentity, 0.0));
    cpShapeSetElasticity(*shape, 0.3)                                                                   ;
    cpShapeSetFriction(*shape, 0.8)                                                                     ;
    cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER) 
  Next
EndProcedure


Procedure updateFuncPlink()
  updateFunc()
  
  ;   If ChipmunkDemoRightDown
  ;     *nearest.cpShape = cpSpacePointQueryNearest(*space, ChipmunkDemoMouse, 0.0, GRAB_FILTER, NULL)
  ;     If nearest
  ;       *body.cpBody = cpShapeGetBody(nearest)
  ;       If cpBodyGetType(*body) = CP_BODY_TYPE_STATIC
  ;         cpBodySetType(*body, CP_BODY_TYPE_DYNAMIC)
  ;         cpBodySetMass(*body, pentagon_mass)       
  ;         cpBodySetMoment(*body, pentagon_moment)   
  ;         ElseIf cpBodyGetType(*body) = CP_BODY_TYPE_DYNAMIC
  ;           cpBodySetType(*body, CP_BODY_TYPE_STATIC)
  ;         EndIf
  ;       EndIf
  ;     EndIf
  ;     
  cpSpaceEachBody(*space, @eachBody(), #Null)
  
  
EndProcedure


Procedure destroyFuncPlink()
  destroyFunc()
EndProcedure

AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "Plink"
ChipmunkDemo()\timestep = 1.0/60
ChipmunkDemo()\initFunc = @initFuncPlink()
ChipmunkDemo()\updateFunc = @updateFuncPlink()
ChipmunkDemo()\destroyFunc = @destroyFuncPlink()
; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 73
; FirstLine = 69
; Folding = -
; EnableXP